ALTER TABLE GENALGTEST
DROP CONSTRAINT foreign_key;
ALTER TABLE TEST
DROP CONSTRAINT foreign_key2;
ALTER TABLE GENERATION
DROP CONSTRAINT foreign_key3;
ALTER TABLE PC
DROP CONSTRAINT prim_key;
ALTER TABLE GENALGTEST
DROP CONSTRAINT prim_key2;
ALTER TABLE TEST
DROP CONSTRAINT prim_key3;
ALTER TABLE GENERATION
DROP CONSTRAINT prim_key4;

DROP TABLE PC;
DROP TABLE GENALGTEST;
DROP TABLE TEST;
DROP TABLE GENERATION;

CREATE TABLE PC
(
    PC_id  number (10,0) NOT NULL,
    os_type varchar2 (10),
    mem_cap number (6,0),
    CPU_cap number (6,0),
    CONSTRAINT prim_key PRIMARY KEY (PC_id) 
);

CREATE TABLE GENALGTEST
(
    GA_id number (32,0) NOT NULL
    ,PC_id  number (10,0) NOT NULL
    ,elitism number(1,0)
    ,mutation_rate number(3,0)
    ,mutation_type varchar2 (12) /* Boundary, Non-Uniform, Uniform */
    ,crossover_rate number(3,0)
    ,crossover_type varchar2 (12) /* One Point, Two Point, Uniform */
    ,population_size number (3,0)
    ,generation_size number (3,0)
    ,test_number number (4,0)
    ,crossrate_change number (3,0)
    ,mutation_rate_change number (3,0)
    ,population_rate_change number (3,0)
    ,salesman_number number (3,0)
    ,fixed_charge number (2,0)
    ,CONSTRAINT prim_key2 PRIMARY KEY (GA_id,PC_id)
    ,CONSTRAINT foreign_key FOREIGN KEY (PC_id) REFERENCES PC(PC_id)
);

CREATE TABLE TEST
(
    GA_id number (32,0) NOT NULL
    ,PC_id  number (10,0) NOT NULL
    ,act_test_num number (4,0) NOT NULL
    ,city_number number (5,0)
    ,CONSTRAINT prim_key3 PRIMARY KEY (GA_id,PC_id,act_test_num)
    ,CONSTRAINT foreign_key2 FOREIGN KEY (GA_id,PC_id) REFERENCES genalgtest(GA_id,PC_id)
);

CREATE TABLE GENERATION
(
    GA_id number (32,0) NOT NULL
    ,PC_id  number (10,0) NOT NULL
    ,act_test_num number(4,0) NOT NULL
    ,gen_number number (3,0) NOT NULL
    ,summa_fittness number (10,0)
    ,average_fittness number (10,0)
    ,best_fittness number (10,0)
    ,CPU_usage number (6,0)
    ,memory_usage number (6,0)
    ,CONSTRAINT prim_key4 PRIMARY KEY (GA_id,PC_id,act_test_num,gen_number)
    ,CONSTRAINT foreign_key3 FOREIGN KEY (GA_id,PC_id,act_test_num) REFERENCES TEST(GA_id,PC_id,act_test_num)
);